<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
	<title>VueJS Tabs</title>
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.8.2/css/bulma.min.css">
</head>
<body>
	<div id="root" class="container">
		<coupon></coupon>
		<p v-show="couponApplied">The coupon was applied</p>
	</div>
	<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>

	<script type="text/javascript">
		window.Event = new class {
			constructor() {
				this.vue = new Vue();
			}

			fire(event, data = null) {
				this.vue.$emit(event, data);
			}

			listen(event, callback) {
				this.vue.$on(event, callback);
			}
		};

		Vue.component('coupon',{
			template: `
				<input @blur="onCouponApplied">	
			`,
			methods: {
				onCouponApplied() {
					Event.fire('applied');
				}
			}
		});

		let app = new Vue({
			el: '#root',
			data: {
				couponApplied: false
			},
			created() {
				Event.listen('applied', () => {
					this.couponApplied = true;
				});
			}
		});
	</script>
</body>
</html>